'user strict';
var resemble = require('node-resemble-js');
var screenShotPath = './automated-tests/screenshots/actual/';
var expectedPath = './automated-tests/lib/fixtures/expected/';

var compareScreenshotCommand = {
    screenshot: function(fileName, client, callback){
        var filePath = screenShotPath+fileName;
        client.saveScreenshot(filePath, function () {
            client.pause(2000, function () {
                callback();
            });
        });
    },
    compare: function (expectedImg, actualImg, callback) {
        if(!expectedImg && !actualImg) {
            if(callback) {
                callback(false);
            }
        }
        else {
            resemble(screenShotPath + actualImg)
                .compareTo(expectedPath + expectedImg)
                .onComplete(function(data){
                    console.log('perc ' + Number(data.misMatchPercentage));
                    if (Number(data.misMatchPercentage) <= 0.01) {
                        callback(true);
                    } else {
                        callback(false)
                    }
                });
        }
    }
};

module.exports = {
    commands: [compareScreenshotCommand],
    elements: {}
};