var async = require('async');
module.exports = {
    '@tags': ['pd_tutorial'],

    before: function (client) {
        client
            .url('http://localhost:3000')
            .waitForElementVisible('#topmenu', 1000);
    },

    after: function (client) {
        client.end();
    },

    /**
     * Test: 6-001
     * Expects:
     *  - Preferences dialog will appear with 6 buttons
     */
    '6-001': function (client) {
        var preferenceTest = client.page.preferenceManagement();

        async.series([
            function (callback) {
                preferenceTest.expect.element('body').to.be.present;
                callback();
            },
            function (callback) {
                preferenceTest.openDialog(function () {
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@preferenceDialog').to.be.visible;
                callback();
            },
            function (callback) {
                // 6-001
                preferenceTest.expect.element('@packagesBtn').to.be.visible;
                preferenceTest.expect.element('@displayBtn').to.be.visible;
                preferenceTest.expect.element('@versionBtn').to.be.visible;
                preferenceTest.expect.element('@resetBtn').to.be.visible;
                preferenceTest.expect.element('@tutorialBtn').to.be.visible;
                preferenceTest.expect.element('@environmentBtn').to.be.visible;
                callback();
            }
        ], function (err, stdout) {

        });
    },

    /**
     * Test: 6-002
     * Expects:
     *  - Tutorial should start.
     */
    '6-002': function (client) {
        var preferenceTest = client.page.preferenceManagement();

        async.series([
            function (callback) {
                preferenceTest.openDialog(function() {
                    callback();
                });
            },
            function (callback) {
                preferenceTest.clickTutorialButton(function () {
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@tutorialLabelStep').to.have.text.that.equals("You can build your network here.");
                callback();
            },
            function (callback) {
                preferenceTest.clickTutorialNextBtn(function () {
                    client.pause(1000);
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@tutorialLabelStep').to.have.text.that.equals("You can add a new sheet from here");
                callback();
            },
            function (callback) {
                preferenceTest.clickTutorialNextBtn(function () {
                    client.pause(1000);
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@tutorialLabelStep').to.have.text.that.equals("You can reshape the network (Graphiz required)");
                callback();
            },
            function (callback) {
                preferenceTest.clickTutorialNextBtn(function () {
                    client.pause(1000);
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@tutorialLabelStep').to.have.text.that.equals("Here is the list of available nodes");
                callback();
            },
            function (callback) {
                preferenceTest.clickTutorialNextBtn(function () {
                    client.pause(1000);
                    callback();
                });
            },function (callback) {
                preferenceTest.expect.element('@tutorialLabelStep').to.have.text.that.equals("You can search a node from here.");
                callback();
            },
            function (callback) {
                preferenceTest.clickTutorialNextBtn(function () {
                    client.pause(1000);
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@tutorialLabelStep').to.have.text.that.equals("If you have some error, the message will be displayed here");
                callback();
            },
            function (callback) {
                preferenceTest.clickTutorialNextBtn(function () {
                    client.pause(1000);
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@tutorialLabelStep').to.have.text.that.equals("You can upload/download all of your files from here");
                callback();
            },
            function (callback) {
                preferenceTest.clickTutorialNextBtn(function () {
                    client.pause(1000);
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@tutorialLabelStep').to.have.text.that.equals("You can configure, e.g., look&feel, language");
                callback();
            },
            function (callback) {
                preferenceTest.clickTutorialNextBtn(function () {
                    client.pause(1000);
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@tutorialLabelStep').to.have.text.that.equals("You can zoom up or zoom out with this slider");
                callback();
            },
            function (callback) {
                preferenceTest.clickTutorialDoneBtn(function () {
                    client.pause(1000);
                    callback();
                });
            },
            function (callback) {
                preferenceTest.expect.element('@tutorialLayer').to.be.not.present;
                callback();
            }
        ], function (err, stdout) {

        });

        client.end();
    }
}