import unittest
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
import harkdesigner


class PythonNode (harkdesigner.TestHarkDesigner):
    def test_makefig(self):
        self.zoom(3)
        self.setDisplay("Line", "Lines")

        self.addNode("LocalizeMUSIC")
        self.addNode("ExtendedSourceTracker")
        self.addNode("DisplayLocalization")
        self.reshape()

        self.connect("node_LocalizeMUSIC_1", "OUTPUT",
                     "node_ExtendedSourceTracker_1", "INPUT")
        self.connect("node_ExtendedSourceTracker_1", "OUTPUT",
                     "node_DisplayLocalization_1", "SOURCES")

        # take a picture
        self.reshape()

        # raw_input()
        self.screenshot("png", "ExtendedSourceTracker_", True)

if __name__ == "__main__":
    unittest.main()
