import unittest
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
import harkdesigner
import time


class PythonNode (harkdesigner.TestHarkDesigner):
    def test_selectNodeByMouse(self):
        nodes = ["ConstantLocalization", "Constant", "LocalizeMUSIC", "GHDSS"]
        for node in nodes:
            self.addNode(node)
        self.reshape()

        for node in nodes:
            self.selectNode("node_" + node + "_1")
            self.assertNodeSelected("node_" + node + "_1")

    def test_selectNodByKeyboard(self):
        elem = self.driver.find_element_by_id("nodelistSearch")
        elem = elem.find_element_by_css_selector("input")
        nodes = ["ConstantLocalization", "LocalizeMUSIC", "GHDSS"]

        for node in nodes:
            self.addNode(node)

        for node in nodes:
            self.driver.find_element_by_xpath("//body").send_keys(Keys.TAB)
            self.assertNodeSelected("node_" + node + "_1")

    def test_addNodeByKey(self):
        self.assertIn("HARK Designer", self.driver.title)
        elem = self.driver.find_element_by_id("nodelistSearch")
        elem = elem.find_element_by_css_selector("input")
        for node in ["ConstantLocalization",
                     "SourceTracker",
                     "Stderr"]:
            self.addNode(node)
            self.assertNodeExists("node_" + node + "_1")

        for node in ["ConstantLocalization",
                     "SourceTracker",
                     "Stderr"]:
            self.addNode(node)
            self.assertNodeExists("node_" + node + "_2")

    def test_addNodeByMouse(self):
        elems = self.driver.find_elements_by_xpath(
            '//ul[@id="nodelist"]/li[@type="category"]')
        for li in elems[0:5]:
            print li.text
            li.click()
            node = li.find_element_by_css_selector(".nodeElement")
            text = node.text
            node.click()
            self.assertNodeExists("node_" + text + "_1")

    def test_adddelNodes(self):
        for node in ["ConstantLocalization",
                     "SourceTracker",
                     "Stderr"]:
            self.addNode(node)
            self.assertNodeExists("node_" + node + "_1")
        self.reshape()
        for node in ["ConstantLocalization",
                     "SourceTracker",
                     "Stderr"]:
            self.delNode("node_" + node + "_1")
            self.assertNodeNotExists("node_" + node + "_1")

if __name__ == "__main__":
    unittest.main()
