import unittest
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
import harkdesigner


class PythonNode (harkdesigner.TestHarkDesigner):
    def test_ticket1144(self):
        # add a sheet
        self.addSheet("LOOP0")

        # build a sheet
        self.activateSheet("LOOP0")
        self.addNode("LocalizeMUSIC")
        self.addNode("SourceTracker")
        self.addNode("SourceTracker")
        self.reshape()
        self.connect("node_SourceTracker_1", "INPUT",
                     "node_LocalizeMUSIC_1", "OUTPUT")
        self.addTerminalRole("node_LocalizeMUSIC_1", "INPUT",
                             "Input", "")
        self.addTerminalRole("node_SourceTracker_1", "OUTPUT",
                             "Output", "")
        self.addTerminalRole("node_SourceTracker_2", "OUTPUT",
                             "Output", "")

        # test
        print "asserting1"
        self.assertTerminalRoleName(
            "node_SourceTracker_1", "OUTPUT", "OUTPUT")
        print "asserting2"
        self.assertTerminalRoleName(
            "node_SourceTracker_2", "OUTPUT", "OUTPUT_1")

        # add LOOP0
        print "adding LOOP0"
        self.activateSheet("MAIN")
        self.addNode("LOOP0")
        self.assertTermExists("node_LOOP0_1", "OUTPUT_1")
        self.assertTermExists("node_LOOP0_1", "OUTPUT_1")

if __name__ == "__main__":
    unittest.main()
